#include"semaphore.hh"

namespace TT {

  // implementation of the alternative semaphore
  Semaphore::Semaphore (int init) : Condition<unsigned int>(init)
  {
  }

  Semaphore::Semaphore () : Condition<unsigned int>(0)
  {
  }

  void Semaphore::P ()
  {
    // get exclusive access
    aquire();

    // ensure that value of semaphore gets nonnegative
    while (value()==0)
      wait();          // release access and wait
  
    // decrement value
    (value())--;

    // now value is nonnegative; release access
    release();
  }

  void Semaphore::V ()
  {
    // get exclusive access
    aquire();

    // increment value
    (value())++;

    // wake up at most one process
    signal(); 

    // release access
    release(); 
  }

}
